package SQ.Blocks.Indicators.ATRPercentRank;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(APRR) ATR Percent Rank is rising", display="ATR Percent Rank(@Chart@#ATRPeriod#,#Lenght#) is rising", returnType = ReturnTypes.Boolean)
@Help("Is triggered if ATR Percent Rank is rising 2 consecutive bars")
@OppositeBlock("ATRPercentRankRising")
@ParameterSet(set="ATRPeriod=12,Lenght=24")
@ParameterSet(set="ATRPeriod=12,Lenght=48")
@ParameterSet(set="ATRPeriod=12,Lenght=96")
@ParameterSet(set="ATRPeriod=12,Lenght=120")
@ParameterSet(set="ATRPeriod=12,Lenght=10")
@ParameterSet(set="ATRPeriod=12,Lenght=20")
@ParameterSet(set="ATRPeriod=12,Lenght=40")
@ParameterSet(set="ATRPeriod=12,Lenght=60")
@ParameterSet(set="ATRPeriod=12,Lenght=120")
@ParameterSet(set="ATRPeriod=12,Lenght=200")
public class ATRPercentRankRising extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="12", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int ATRPeriod;

	@Parameter(defaultValue="120", isPeriod=true, builderMinValue=2, builderMaxValue=500, minValue=2, maxValue=500, step=1)
	public int Lenght;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		ATRPercentRank indicator = Strategy.Indicators.ATRPercentRank(Chart, ATRPeriod,Lenght);
		double curAPR = indicator.Value.getRounded(Shift,5);
		double prevAPR = indicator.Value.getRounded(Shift+1,5);
		
		return (curAPR > prevAPR);
	}

}