package SQ.Blocks.Indicators.BHErgodic;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(BHED) BH Ergodic is Down", display="BH Ergodic(@Chart@#R#,#S#,#U#,#Trigger#) is Down", returnType = ReturnTypes.Boolean)
@Help("Is triggered if BH Ergodic is Down")
@OppositeBlock(value="BHErgodicUP",oscillator=true, middleValue=0)

public class BHErgodicDown extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="2", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int R;

	@Parameter(defaultValue="10", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int S;

	@Parameter(defaultValue="5", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int U;

	@Parameter(defaultValue="3", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int Trigger;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		BHErgodic indicator = Strategy.Indicators.BHErgodic(Chart, R,S,U,Trigger);
		
		//double prevTSI = indicator.TSI.getRounded(Shift + 1);
		//double prevSignal = indicator.Signal.getRounded(Shift + 1);
		double curTSI = indicator.TSI.getRounded(Shift);
		double curSignal = indicator.Signal.getRounded(Shift);
		
		return (curTSI < curSignal);
	}

}