package SQ.Blocks.Indicators.CSSAMarketRegime;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(CMRAL) CSSA Market Regime is above Level", display="CSSA Market Regime(@Chart@#HLSumPeriod#,#HLPeriod#,#AvgPeriod#,#PercRankPeriod#)[#Shift#] is above #Level#", returnType = ReturnTypes.Boolean)
@OppositeBlock(value="CSSAMarketRegimeAboveLevel", oscillator=false, middleValue=50, field="Level")
@ParameterSet(set="HLSumPeriod=5,HLPeriod=10,AvgPeriod=60,PercRankPeriod=120")
@ParameterSet(set="HLSumPeriod=10,HLPeriod=20,AvgPeriod=60,PercRankPeriod=120")
@ParameterSet(set="HLSumPeriod=20,HLPeriod=40,AvgPeriod=60,PercRankPeriod=120")
@ParameterSet(set="HLSumPeriod=5,HLPeriod=10,AvgPeriod=120,PercRankPeriod=120")
@ParameterSet(set="HLSumPeriod=10,HLPeriod=20,AvgPeriod=120,PercRankPeriod=240")
@ParameterSet(set="HLSumPeriod=10,HLPeriod=20,AvgPeriod=120,PercRankPeriod=240")
@ParameterSet(set="HLSumPeriod=20,HLPeriod=40,AvgPeriod=120,PercRankPeriod=240")
@ParameterSet(set="HLSumPeriod=40,HLPeriod=80,AvgPeriod=120,PercRankPeriod=240")
public class CSSAMarketRegimeAboveLevel extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="10", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int HLSumPeriod;

	@Parameter(defaultValue="10", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int HLPeriod;

	@Parameter(defaultValue="60", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int AvgPeriod;

	@Parameter(defaultValue="120", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int PercRankPeriod;
	
	@Parameter(defaultValue="50", isPeriod=false, minValue=0, maxValue=100, step=0.1)
	public double Level;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		CSSAMarketRegime indicator = Strategy.Indicators.CSSAMarketRegime(Chart, HLSumPeriod,HLPeriod,AvgPeriod,PercRankPeriod);
		double value = indicator.Value.getRounded(Shift);
	
		return (value > Level) ;
	}

}