package SQ.Blocks.Indicators.ChoppinessIndex;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;
import SQ.Calculators.SumCalculator;
import SQ.Internal.IndicatorBlock;


@BuildingBlock(name="(CHI) Choppiness Index", display="Choppiness Index(#Period#)[#Shift#]", returnType = ReturnTypes.Number)
@Indicator(oscillator=false, min=0, max=100, step=0.01)

public class ChoppinessIndex extends IndicatorBlock {

	@Parameter
	public ChartData Chart;

	@Parameter(defaultValue="10", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int Period;

	@Output
	public DataSeries Value;


	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	@Override
	protected void OnBarUpdate() throws TradingException {

        double atrSum =  0.00;
      	double maxHig = Chart.High.get(0);
      	double minLow =  Chart.Low.get(0);
		double _log = Math.log(Period)/100.00;
		
		
		if (CurrentBar < Period) {
			
			Value.set(0, 0);

		} else {
	
			for(int i = 0;i<Period;i++){ 

				atrSum = atrSum+ (Math.max(Chart.High.get(i),Chart.Close.get(i+1))-Math.min(Chart.Low.get(i),Chart.Close.get(i+1)));
				maxHig = Math.max(maxHig,Math.max(Chart.High.get(i),Chart.Close.get(i+1)));
				minLow = Math.min(minLow,Math.min(Chart.Low.get(i),Chart.Close.get(i+1)));

			}
			
			double chop = (maxHig!=minLow) ? Math.log(atrSum/(maxHig-minLow))/_log : 0;
			Value.set(0,  chop);

		}
	}
}