package SQ.Blocks.Indicators.ChoppinessIndex;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(CHICBL) Choppiness Index crosses below Level", display="Chopiness Index(@Chart@#Period#) crosses below #Level#", returnType = ReturnTypes.Boolean)
@Help("Is triggered if ChoppinessIndex crosses below level")
@OppositeBlock(value="ChoppinessIndexCrossesBelowLevel", oscillator=false,field="Level")
@ParameterSet(set="Period=10")
@ParameterSet(set="Period=20")
@ParameterSet(set="Period=40")
@ParameterSet(set="Period=80")
@ParameterSet(set="Period=100")
@ParameterSet(set="Period=12")
@ParameterSet(set="Period=24")
@ParameterSet(set="Period=48")
@ParameterSet(set="Period=96")
@ParameterSet(set="Period=120")
public class ChoppinessIndexCrossesBelowLevel extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="10",isPeriod=true, minValue=2, maxValue=10000, step=1)
	public int Period;

	@Parameter(defaultValue="38.2", minValue=0, maxValue=100, builderMinValue=0, builderMaxValue=100, step=0.01)
	public double Level;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		
		ChoppinessIndex indicator = Strategy.Indicators.ChoppinessIndex(Chart, Period);
		double currValue = indicator.Value.getRounded(Shift);
		double prevValue = indicator.Value.getRounded(Shift+1);
		
		return (currValue < Level)&& (prevValue > Level);
	}

}