package SQ.Blocks.Indicators.ChoppinessIndex;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(CHIR) Choppiness Index is rising", display="Chopiness Index(@Chart@#Period#) is rising", returnType = ReturnTypes.Boolean)
@Help("Is triggered if ChoppinessIndex is rising")
@OppositeBlock(value="ChoppinessIndexRising", oscillator=false)
@ParameterSet(set="Period=10")
@ParameterSet(set="Period=20")
@ParameterSet(set="Period=40")
@ParameterSet(set="Period=80")
@ParameterSet(set="Period=100")
@ParameterSet(set="Period=12")
@ParameterSet(set="Period=24")
@ParameterSet(set="Period=48")
@ParameterSet(set="Period=96")
@ParameterSet(set="Period=120")
public class ChoppinessIndexRising extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="10",isPeriod=true, minValue=2, maxValue=10000, step=1)
	public int Period;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		
		ChoppinessIndex indicator = Strategy.Indicators.ChoppinessIndex(Chart, Period);
		double currValue = indicator.Value.getRounded(Shift);
		double prevValue = indicator.Value.getRounded(Shift+1);
		
		return (currValue > prevValue);
	}

}