package SQ.Blocks.Indicators.DSSBressert;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(DSSCD) DSS Bressert crosses below trigger line", display="DSS Bressert crosses below trigger line(@Chart@#StochPeriod#,#EMAPeriod#,#TriggerPeriod#)", returnType = ReturnTypes.Boolean)
@OppositeBlock(value="DSSBressertCrossUP",oscillator=true, middleValue=50)

@ParameterSet(set="StochPeriod=10,EMAPeriod=9,TriggerPeriod=5")
@ParameterSet(set="StochPeriod=20,EMAPeriod=18,TriggerPeriod=10")
@ParameterSet(set="StochPeriod=30,EMAPeriod=18,TriggerPeriod=10")


public class DSSBressertCrossDown extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="10", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int StochPeriod ;

	@Parameter(defaultValue="9", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int EMAPeriod;

	@Parameter(defaultValue="5", isPeriod=true, minValue=2, maxValue=1000, step=1)
	public int TriggerPeriod;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		double DSS = Strategy.Indicators.DSSBressert(Chart, StochPeriod,EMAPeriod,TriggerPeriod).DSS.getRounded(Shift);
		double Trigger = Strategy.Indicators.DSSBressert(Chart, StochPeriod,EMAPeriod,TriggerPeriod).Trigger.getRounded(Shift);
		double prevDSS = Strategy.Indicators.DSSBressert(Chart, StochPeriod,EMAPeriod,TriggerPeriod).DSS.getRounded(Shift+1);
		double prevTrigger = Strategy.Indicators.DSSBressert(Chart, StochPeriod,EMAPeriod,TriggerPeriod).Trigger.getRounded(Shift+1);

		return (prevDSS > prevTrigger) && (DSS < Trigger);
	}

}