package SQ.Blocks.Indicators.DisparityIndex;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(DIBL) Disparity Index is below Level", display="Disparity Index(@Chart@#Period#) is below #Level#", returnType = ReturnTypes.Boolean)
@Help("Is triggered if Disparity Index is below Level")
@OppositeBlock(value="DisparityIndexAboveLevel",oscillator=true, middleValue=0,field="Level")
@ParameterSet(set="Period=10")
@ParameterSet(set="Period=20")
@ParameterSet(set="Period=30")
@ParameterSet(set="Period=40")
@ParameterSet(set="Period=50")
@ParameterSet(set="Period=60")
@ParameterSet(set="Period=12")
@ParameterSet(set="Period=24")
@ParameterSet(set="Period=48")
@ParameterSet(set="Period=96")
@ParameterSet(set="Period=120")
@ParameterSet(set="Period=100")
public class DisparityIndexBelowLevel extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="14", minValue=2, maxValue=10000, step=1)
	public int Period;

	@Parameter(defaultValue="0", minValue=-10, maxValue=10, step=0.01)
	public double Level;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		DisparityIndex indicator = Strategy.Indicators.DisparityIndex(Chart, Period);
		double curVal = indicator.Value.getRounded(Shift);
		double prevVal = indicator.Value.getRounded(Shift + 1);

		return (curVal < Level);
	}

}