package SQ.Blocks.Indicators.DisparityIndex;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(DICAL) Disparity Index crosses above Level", display="Disparity Index(@Chart@#Period#) crosses above #Level#", returnType = ReturnTypes.Boolean)
@Help("Is triggered if Disparity Index crosses above Level")
@OppositeBlock(value="DisparityIndexCrossesBelowLevel",oscillator=true, middleValue=0,field="Level")
@ParameterSet(set="Period=10,Level=0")
@ParameterSet(set="Period=20,Level=0")
@ParameterSet(set="Period=30,Level=0")
@ParameterSet(set="Period=40,Level=0")
@ParameterSet(set="Period=50,Level=0")
@ParameterSet(set="Period=60,Level=0")
@ParameterSet(set="Period=12,Level=0")
@ParameterSet(set="Period=24,Level=0")
@ParameterSet(set="Period=48,Level=0")
@ParameterSet(set="Period=96,Level=0")
@ParameterSet(set="Period=120,Level=0")
@ParameterSet(set="Period=100,Level=0")
public class DisparityIndexCrossesAboveLevel extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="14", minValue=2, maxValue=10000, step=1)
	public int Period;

	@Parameter(defaultValue="0", minValue=-10, maxValue=10, step=0.01)
	public double Level;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		DisparityIndex indicator = Strategy.Indicators.DisparityIndex(Chart, Period);
		double curVal = indicator.Value.getRounded(Shift);
		double prevVal = indicator.Value.getRounded(Shift + 1);

		return (prevVal < Level)&&(curVal > Level);
	}

}