package SQ.Blocks.Indicators.MoneyFlowIndex;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(MFICAL) Money Flow Index crosses above Level", display="Money Flow Index(@Chart@#Period#) crosses above #Level#", returnType = ReturnTypes.Boolean)
@Help("Is triggered if MoneyFlowIndex crosses above Level")
@OppositeBlock(value="MoneyFlowIndexCrossBelowLevel", oscillator=true, middleValue=50, field="Level")

@ParameterSet(set="Period=14")
@ParameterSet(set="Period=20")
@ParameterSet(set="Period=30")
@ParameterSet(set="Period=40")
@ParameterSet(set="Period=50")
@ParameterSet(set="Period=100")
@ParameterSet(set="Period=12")
@ParameterSet(set="Period=24")
@ParameterSet(set="Period=48")
@ParameterSet(set="Period=96")
@ParameterSet(set="Period=120")
public class MoneyFlowIndexCrossAboveLevel extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="14", minValue=2, maxValue=10000, step=1)
	public int Period;

	@Parameter(defaultValue="80", minValue=0, maxValue=100, step=0.1)
	public int Level;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		MoneyFlowIndex indicator = Strategy.Indicators.MoneyFlowIndex(Chart, Period);
		
		double curr = indicator.Value.getRounded(Shift);
		double prev = indicator.Value.getRounded(Shift+1);
		
		return (curr > Level)&&(prev < Level);
	}

}