package SQ.Blocks.Indicators.MoneyFlowIndex;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(MFIF) Money Flow Index is falling", display="Money Flow Index(@Chart@#Period#) is falling", returnType = ReturnTypes.Boolean)
@Help("Is triggered if MoneyFlowIndex is rising 2 bars")
@OppositeBlock("MoneyFlowIndexRising")
@ParameterSet(set="Period=14")
@ParameterSet(set="Period=20")
@ParameterSet(set="Period=30")
@ParameterSet(set="Period=40")
@ParameterSet(set="Period=50")
@ParameterSet(set="Period=100")
@ParameterSet(set="Period=12")
@ParameterSet(set="Period=24")
@ParameterSet(set="Period=48")
@ParameterSet(set="Period=96")
@ParameterSet(set="Period=120")
public class MoneyFlowIndexFalling extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="14", minValue=2, maxValue=10000, step=1)
	public int Period;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		MoneyFlowIndex indicator = Strategy.Indicators.MoneyFlowIndex(Chart, Period);
		double prev = indicator.Value.getRounded(Shift + 1);
		double curr = indicator.Value.getRounded(Shift);
		
		return (curr < prev);
	}

}