package SQ.Blocks.Indicators.RVI;

import SQ.Internal.ConditionBlock;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

@BuildingBlock(name="(RVIAL) RVI is above level", display="RVI(@Chart@#Period#) is above #Level#", returnType = ReturnTypes.Boolean)
@Help("Is triggered if RVI is above level")
@OppositeBlock(value="RVIBelowLevel",oscillator=true,middleValue=0,field="Level")
@ParameterSet(set="Period=10,Level=0")
@ParameterSet(set="Period=20,Level=0")
@ParameterSet(set="Period=30,Level=0")
@ParameterSet(set="Period=40,Level=0")
@ParameterSet(set="Period=50,Level=0")
@ParameterSet(set="Period=60,Level=0")
@ParameterSet(set="Period=12,Level=0")
@ParameterSet(set="Period=24,Level=0")
@ParameterSet(set="Period=48,Level=0")
@ParameterSet(set="Period=96,Level=0")
@ParameterSet(set="Period=120,Level=0")
@ParameterSet(set="Period=100,Level=0")
public class RVIAboveLevel extends ConditionBlock {
	
	@Parameter
	public ChartData Chart;
	
	@Parameter(defaultValue="14", minValue=2, maxValue=10000, step=1)
	public int Period;

	@Parameter(defaultValue="0", minValue=-1, maxValue=1, step=0.01)
	public double Level;

	@Parameter
	public int Shift;
	
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	
	@Override
	public boolean OnBlockEvaluate() throws TradingException {
		RVI indicator = Strategy.Indicators.RVI(Chart, Period);
		double curVal = indicator.RVI.getRounded(Shift);
		double prevVal = indicator.RVI.getRounded(Shift + 1);
		
		
		return (curVal > Level);
	}

}