package SQ.Columns.Databanks;
import java.util.ArrayList; // import the ArrayList class
import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;
import com.strategyquant.tradinglib.ResultsGroup;
import com.strategyquant.tradinglib.ValueTypes;
import com.strategyquant.tradinglib.results.SpecialValues;
import it.unimi.dsi.fastutil.doubles.DoubleArrayList;
import it.unimi.dsi.fastutil.ints.IntArrayList;

import java.util.*; 

import java.util.List;

// Source SQX / Clonex, Modified in France by Emmanuel Bouillant-Evrard for the StrategyQuantX Community :)
public class AllMarketsWinningPct extends DatabankColumn 
{

	String stratMetric = "WinningPct";

	public AllMarketsWinningPct() 
	{
		super(L.tsq("AllM WinningPct"),  DatabankColumn.Decimal2Pct, ValueTypes.Maximize, 0, -5, 5);
	
		setWidth(100); // defaultcolumn width in pixels

		setTooltip("All Markets WinningPct Average");  

		/* If this new column is dependent on some other columns that have to vbe computed first, put them here.
       Make sure you don't creat circular dependency, such as A depends on B and B depends on A.
       Columns (=stats values) are identified by the name of class)
		 */
		setDependencies(stratMetric);

	}


	@Override
	public double  compute(SQStats stats, StatsTypeCombination combination, OrdersList ordersList, SettingsMap settings, SQStats statsLong, SQStats statsShort, Result result, SettingsMap rgSpecialValues) throws Exception 
	{
		if(result == null) 
		{
			return -1;
		}

		ResultsGroup rg =  result.getResultsGroup();
		String MainResultKey = rg.getMainResultKey();

		double	Var1=0;
		Var1=0;

		Var1 += stats.getDouble(stratMetric);
		//fdebug(" All Markets "," MainResultKey : " + MainResultKey + "   " + Var1);
		if(!result.getResultKey().equals(ResultsGroup.Portfolio)) 
		{
			//fdebug(" All Markets"," MainResultKey : " + MainResultKey + "   " + Var1);
			return -2;
		}

		DoubleArrayList npList = new DoubleArrayList();
		npList.add(Var1);
		
		byte direction = combination.getDirection();
		byte plType = combination.getPLType();
		byte sampleType = combination.getSampleType();

		for (String adMarketKey : rg.additionalMarketKeys())
		{
			Result rs = rg.subResult(adMarketKey);
			SQStats adResultStats = rs.stats(direction, plType, sampleType);
			npList.add(adResultStats.getDouble(stratMetric));
			//fdebug(" All Markets"," adMarketKey : " + adMarketKey + "   " + adResultStats.getDouble(stratMetric));
		}

		npList.sort(null);
		double[] tempArray = new double[npList.size()];
		npList.toArray(tempArray);
		double res = 0;

		res = Average1(tempArray);
	//	fdebug(" All Markets ","   " + stratMetric + "   " + res);
		return res;
	}


	private double Average1(double a[]) 
	{ 
		if (a.length==0){return 0;}
			double Total = 0 ;
			for (int i1 = 0; i1 < a.length; i1++)
			{
				Total += a[i1];
			}

		return (double)Total / (double)a.length; 
	} 
}