package SQ.Columns.Databanks;

import com.strategyquant.lib.L;
import com.strategyquant.lib.SQTime;
import com.strategyquant.lib.SQUtils;
import com.strategyquant.tradinglib.*;
import com.strategyquant.tradinglib.databank.DatabankTableColumnEntry;
import com.strategyquant.tradinglib.optimization.OptimizationProfile;
import com.strategyquant.tradinglib.optimization.OptimizationTestResult;
import com.strategyquant.tradinglib.optimization.WalkForwardMatrixResult;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;

import java.util.ArrayList;

public class MAOfWDrawdownPct extends DatabankColumn {

    public MAOfWDrawdownPct() {
        super(L.tsq("Avg. Drawdown Pct. WF IS"), DatabankColumn.Decimal4, ValueTypes.Maximize, 0, 0, 1);

        setWidth(120);
    }

    //------------------------------------------------------------------------

    @Override
    public double getNumericValue(ResultsGroup rg, String resultKey, byte direction, byte plType, byte sampleType) throws Exception {

        WalkForwardMatrixResult mwfResult = (WalkForwardMatrixResult) rg.mainResult().get(SettingsKeys.WalkForwardResult);
        if(mwfResult == null) {
            return -1;
        }

        ArrayList<WalkForwardResult> wfResults = mwfResult.getResultList();
        if(wfResults == null || wfResults.isEmpty()) {
            return -2;
        }

        for(int i=0; i<wfResults.size(); i++) {
            WalkForwardResult wfResult = wfResults.get(i);
            //fdebug("WF--->","fResult:"+wfResult);
        }
        // zoberieme len najlepsi WF result (ak je to matrix, ma vela WF resultov)
        WalkForwardResult wfResult = mwfResult.getWFResult(rg.getBestWFResultKey(), true);

        
        
        ArrayList<WalkForwardResult> test = mwfResult.getResultList();

         for(int k=0; k<test.size(); k++) {
            WalkForwardResult testResult  = test.get(k);
          
        }

        ArrayList<WalkForwardPeriod> periods = wfResult.wfPeriods;

        if(periods == null || periods.size() <= 0) {
            return -3;
        }

        double sumISValue = 0;
        for(int j=0; j<periods.size(); j++) {
            WalkForwardPeriod period = periods.get(j);

            // ziskanie datumov
            // datumy IS od-do: period.optimizeFrom, period.optimizeTo
            // datumy OOS od-do: period.runFrom, period.runTo
            // napr. SQTime.toDateString(period.runFrom)

            // ziskanie poctu dni IS/OOS:
            // SQTime.getDaysBetween(period.optimizeFrom, period.optimizeTo) //Days IS
            // SQTime.getDaysBetween(period.runFrom, period.runTo) //Days OOS

            // IS stats
            // period.optimizationStatData
            // OOS stats
            //  period.runStatData

            // suma
            
            
            sumISValue += period.optimizationStatData.getDouble("DrawdownPct");
        }

        double avgIsValue = sumISValue / periods.size();

        return avgIsValue;
    }

    //------------------------------------------------------------------------

    @Override
    public String getValue(ResultsGroup rg, String resultKey, byte direction, byte plType, byte sampleType) throws Exception {

        double avgIsValue = SQUtils.round2( getNumericValue(rg, resultKey, direction, plType, sampleType) );

        return Double.toString(avgIsValue);
    }
}
