package SQ.Columns.Databanks;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

public class StatSignificance extends DatabankColumn {
    
	public StatSignificance() {
		super(L.t("Stat. Significance"), DatabankColumn.Decimal2, ValueTypes.Maximize, 0, 0, 50);
		
	
		setDependencies("Complexity", "AvgTradesPerYear");
		setTooltip(L.t("Stat. Significance"));

	}
	
	//------------------------------------------------------------------------

	@Override
	public double compute(SQStats stats, StatsTypeCombination combination, OrdersList ordersList, SettingsMap settings, SQStats statsLong, SQStats statsShort) throws Exception {

		int complexity = stats.getInt("Complexity");
		double avgTradesPerYear = stats.getDouble("AvgTradesPerYear");



		return round2(safeDivide((double)avgTradesPerYear,(double) complexity));	 
	}
	
}