package SQ.WhatIf;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.strategyquant.lib.SQTime;
import com.strategyquant.tradinglib.ClassConfig;
import com.strategyquant.tradinglib.Help;
import com.strategyquant.tradinglib.Order;
import com.strategyquant.tradinglib.OrdersList;
import com.strategyquant.tradinglib.Parameter;
import com.strategyquant.tradinglib.WhatIf;
import com.strategyquant.tradinglib.results.stats.comparator.OrderComparatorByOpenTime;

import it.unimi.dsi.fastutil.objects.ObjectListIterator;

@ClassConfig(name="() Equity MA Trading", display="Equity MA Trading (#MAPeriod#)")
@Help("Help text")
public class EquityMATrading extends WhatIf {
	public static final Logger Log = LoggerFactory.getLogger(EquityMATrading.class);
	
	
	@Parameter(name="MAPeriod", defaultValue="10", minValue=2, maxValue=100000, step=1)
	public int MAPeriod;

	@Override
	public void filter(OrdersList orders) throws Exception {

		// New instance of OrdersList in which we store trades that are above the moving average 
		OrdersList newOL = new OrdersList("AboveMovingAverage"); 
		
		// We are looping trough whole OrdersList orders in order to compute Moving Average
		for(int i = MAPeriod;i < orders.size();i++){

			// Current last order we are deciding whether or not to go to newOL 
			Order order = orders.get(i); 
	
			// get balance of order	
			double balance = order.AccountBalance;
			
			// filter balanced orders
			if(order.isBalanceOrder()) continue; 

				double sum = 0;		
				// compute Moving Average of Equity 
				for(int k =1;k<=MAPeriod;k++){ /// robim ma , pricom zaratavam prvy  orders.get(i-1) a posledny orders.get(i-MAPeriod) pri vyratavani MA
					Order o = orders.get(i-k);
					
					sum = sum + o.AccountBalance; // o.PL = order Profit/Loss
				}
				// average of equity 
				double avg = sum/MAPeriod; 
				// we are comparing get(i-1) with moving average
				Order lastOrder = orders.get(i-1); 
				
				// if last order equity > average of equity 
				if(lastOrder.AccountBalance>avg) { 
					// we add order.get(i) to newOL 
					newOL.add(order);  		
				}				
				avg =0; // reset average variable
				sum =0;	// reset sum variable	
			}
			// sorting newOL by positions open time
			newOL.sort(new OrderComparatorByOpenTime()); //// toto som si osvojil vdaka tvojmu novemu clanku ael realne to asi netreba ale podla mna to je dobra praktika
			// we are replacing OrdersList orders with OrdersList newOL and we recieve only trades above moving average
			orders.replaceWithList​(newOL); 
		}

}